unit AiLongDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Caio, AppEvnts, TeEngine, Series, ExtCtrls, TeeProcs, Chart;

type
  TForm1 = class(TForm)
    Edit_Device: TEdit;
    Label1: TLabel;
    ComboBox_AioSetAiRange: TComboBox;
    Label4: TLabel;
    Button_AioInit: TButton;
    Button_Set: TButton;
    Button_StartAi: TButton;
    Button_AioStopAi: TButton;
    Button_GetStatus: TButton;
    ButtonAioExit: TButton;
    Label5: TLabel;
    Label_AiSamplingTimes: TLabel;
    Label7: TLabel;
    Label_AiStatus: TLabel;
    Label_Event: TLabel;
    Label_AiTotalSamplingTimes: TLabel;
    Memo_ErrorString: TMemo;
    Chart1: TChart;
    Series1: TFastLineSeries;
    Label2: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    procedure Button_AioInitClick(Sender: TObject);
    procedure Button_AioExitClick(Sender: TObject);
    procedure ComboBox_AioSetAiRangeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button_SetClick(Sender: TObject);
    procedure Button_StartAiClick(Sender: TObject);
    procedure Button_GetStatusClick(Sender: TObject);
    procedure Button_AioStopAiClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
    procedure thartout(DatNo:integer);      // Ot\
    procedure MessTest(var Msg: Tmessage);  // bZ[W`FbNp
  public
    { Public 錾 }
    procedure ErrorMemoOut(title: string);  // ErroreTmemo\
  end;

const
  // f[^[TvOő吔
  DATA_MAX = 10000;
var
  Form1: TForm1;
  //֐̖߂l
  Ret: Longint;
  Ret2: Longint;
  //ID
  Id: Smallint;
  //gp`l
  AiChannels: SmallInt;
  //G[R[h
  ErrorString: array [0..256] of AnsiChar;
  //ϊf[^i[pz
  AiData: array of Single;
  //Cxg
  AiEventCount: Longint;
  //擾TvO
  AiTotalSamplingTimes: Longint;
  // windows handle
  FWindowHandle: HWND;
  //ϊx̐ݒF1000usec
  SAMCLOCK:     LongInt = 1000;
  // Aio FinFout event time  荞ݔ
  DATATIME:     LongInt = 50;


implementation

{$R *.DFM}

//--------------------------------------------------------------------------------------------------
//  tH[̍쐬
//--------------------------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  //AiO̓WpR{{bNX̍쐬
  ComboBox_AioSetAiRange.Items.Add('-10 - +10V');
  ComboBox_AioSetAiRange.Items.Add('-5 - +5V');
  ComboBox_AioSetAiRange.Items.Add('-2.5 - +2.5V');
  ComboBox_AioSetAiRange.Items.Add('-1.25 - +1.25V');
  ComboBox_AioSetAiRange.Items.Add('-1 - +1V');
  ComboBox_AioSetAiRange.Items.Add('-0.625 - +0.625V');
  ComboBox_AioSetAiRange.Items.Add('-0.5 - +0.5V');
  ComboBox_AioSetAiRange.Items.Add('-0.3125 - +0.3125V');
  ComboBox_AioSetAiRange.Items.Add('-0.25 - +0.25V');
  ComboBox_AioSetAiRange.Items.Add('-0.125 - +0.125V');
  ComboBox_AioSetAiRange.Items.Add('-0.1 - +0.1V');
  ComboBox_AioSetAiRange.Items.Add('-0.05 - +0.05V');
  ComboBox_AioSetAiRange.Items.Add('-0.025 - +0.025V');
  ComboBox_AioSetAiRange.Items.Add('-0.0125 - +0.0125V');
  ComboBox_AioSetAiRange.Items.Add('0 - +10V');
  ComboBox_AioSetAiRange.Items.Add('0 - +5V');
  ComboBox_AioSetAiRange.Items.Add('0 - +4.095V');
  ComboBox_AioSetAiRange.Items.Add('0 - +2.5V');
  ComboBox_AioSetAiRange.Items.Add('0 - +1.25V');
  ComboBox_AioSetAiRange.Items.Add('0 - +1V');
  ComboBox_AioSetAiRange.Items.Add('0 - +0.5V');
  ComboBox_AioSetAiRange.Items.Add('0 - +0.25V');
  ComboBox_AioSetAiRange.Items.Add('0 - +0.1V');
  ComboBox_AioSetAiRange.Items.Add('0 - +0.05V');
  ComboBox_AioSetAiRange.Items.Add('0 - +0.025V');
  ComboBox_AioSetAiRange.Items.Add('0 - +0.0125V');
  ComboBox_AioSetAiRange.Items.Add('0 - +20mA');
  ComboBox_AioSetAiRange.Items.Add('4 - +20mA');
  ComboBox_AioSetAiRange.Items.Add('1 - +5V');
  ComboBox_AioSetAiRange.ItemIndex := 0;
  // Tmemo Clear
  Memo_ErrorString.Clear;
  // windowsHandel ̐ݒ
  FWindowHandle := AllocateHWnd(MessTest);
end;

//--------------------------------------------------------------------------------------------------
//  G[̓e\
//--------------------------------------------------------------------------------------------------
procedure TForm1.ErrorMemoOut(title: string);  // ErroreTmemo\
begin
  Ret2 := AioGetErrorString(Ret, @ErrorString);
  // Format ErrorStringAnsicode  unicodeɕϊ
  Memo_ErrorString.Text := title + Format(' = %d : %s', [Ret, ErrorString]);
end;

//--------------------------------------------------------------------------------------------------
//  foCX̏
//--------------------------------------------------------------------------------------------------
procedure TForm1.Button_AioInitClick(Sender: TObject);
begin
  //  unicodeȂ̂ansicodeɕϊ
  Ret := AioInit(PansiChar(ansiString(Edit_Device.text)), @Id);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioInit');  // ErroreTmemo\
      Exit;
    end;

  //foCX̃Zbg
  Ret := AioResetDevice(Id);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioResetDevice');  // ErroreTmemo\
      Exit;
    end;

  Memo_ErrorString.Text := ' : I';
end;

//--------------------------------------------------------------------------------------------------
//  AiO̓W̐ݒ
//--------------------------------------------------------------------------------------------------
procedure TForm1.ComboBox_AioSetAiRangeClick(Sender: TObject);
var
  AiRange: Smallint;
begin
  case(ComboBox_AioSetAiRange.ItemIndex) of
    0:AiRange := PM10;
    1:AiRange := PM5;
    2:AiRange := PM25;
    3:AiRange := PM125;
    4:AiRange := PM1;
    5:AiRange := PM0625;
    6:AiRange := PM05;
    7:AiRange := PM03125;
    8:AiRange := PM025;
    9:AiRange := PM0125;
    10:AiRange := PM01;
    11:AiRange := PM005;
    12:AiRange := PM0025;
    13:AiRange := PM00125;
    14:AiRange := P10;
    15:AiRange := P5;
    16:AiRange := P4095;
    17:AiRange := P25;
    18:AiRange := P125;
    19:AiRange := P1;
    20:AiRange := P05;
    21:AiRange := P025;
    22:AiRange := P01;
    23:AiRange := P005;
    24:AiRange := P0025;
    25:AiRange := P00125;
    26:AiRange := P20MA;
    27:AiRange := P4TO20MA;
    28:AiRange := P1TO5;
  else
    AiRange := 0;
  end;

  //̓W̐ݒ
  Ret := AioSetAiRangeAll(Id, AiRange);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AAioSetAiRangeAll');  // ErroreTmemo\
      Exit;
    end;

  Memo_ErrorString.Text := 'Wݒ : I';
end;

//--------------------------------------------------------------------------------------------------
//   ϊݒ
//--------------------------------------------------------------------------------------------------
procedure TForm1.Button_SetClick(Sender: TObject);
var
  AiEvent: Longint;
  Check  : integer;
begin
  series1.Clear;
  Label_AiSamplingTimes.Caption := '0';
  Label_Event.Caption := '0';
  Label_AiTotalSamplingTimes.Caption := '0';
  AiEventCount := 0;
  AiTotalSamplingTimes := 0;

  // Aio FinFout event time  荞ݔ
  val(Edit1.Text, DATATIME, check);
  if check <> 0 then exit;

  //ϊx̐ݒF1000usec
  val(Edit2.Text, SAMCLOCK, check);
  if check <> 0 then exit;

  //`l̐ݒF1`l
  AiChannels := 1;
  Ret := AioSetAiChannels(Id, AiChannels);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioSetAiChannels');     // ErroreTmemo\
      Exit;
    end;

  //`̐ݒF0 FIFO  1 Ring
  Ret := AioSetAiMemoryType(Id, 0);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioSetAiMemoryType');   // ErroreTmemo\
      Exit;
    end;

  //NbNނ̐ݒF 0
  Ret := AioSetAiClockType(Id, 0);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioSetAiClockType');    // ErroreTmemo\
      Exit;
    end;

  //ϊx̐ݒF1000usec
  Ret := AioSetAiSamplingClock(Id, SAMCLOCK);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioSetAiSamplingClock');  // ErroreTmemo\
      Exit;
    end;

  //Jn̐ݒF\tgEFA
  Ret := AioSetAiStartTrigger(Id, 0);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioSetAiStartTrigger');   // ErroreTmemo\
      Exit;
    end;

  //~̐ݒFR}h
  Ret := AioSetAiStopTrigger(Id, 4);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioSetAiStopTrigger');    // ErroreTmemo\
      Exit;
    end;
  //荞ݔ@񐔂̐ݒ
  Ret := AioSetAiEventSamplingTimes(ID, DATATIME);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioSetAiStopTrigger');    // ErroreTmemo\
      Exit;
    end;

  //Cxgv̐ݒFfoCXIAwTvO񐔊i[A
  //                    I[o[t[ANbNG[AADϊG[
  AiEvent := AIE_DATA_NUM Or AIE_OFERR Or AIE_SCERR Or AIE_ADERR Or AIE_END;
  Ret := AioSetAiEvent(Id, FWindowHandle, AiEvent);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioSetAiEvent');    // ErroreTmemo\
      Exit;
    end;

  Memo_ErrorString.Text := 'ϊݒFI';

end;

//--------------------------------------------------------------------------------------------------
//   ϊJn
//--------------------------------------------------------------------------------------------------
procedure TForm1.Button_StartAiClick(Sender: TObject);
begin
  //̃Zbg
  Ret := AioResetAiMemory(Id);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioResetAiMemory');   // ErroreTmemo\
      Exit;
    end;

  //ϊJn
  Ret := AioStartAi(Id);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioStartAi');         // ErroreTmemo\
      Exit;
    end;

  Memo_ErrorString.Text := 'ϊJn : I';
end;

//--------------------------------------------------------------------------------------------------
//   ϊԎ擾
//--------------------------------------------------------------------------------------------------
procedure TForm1.Button_GetStatusClick(Sender: TObject);
var
  AiSamplingCount: Longint;
  AiStatus: Longint;
begin
  //i[TvO̎擾
  Ret := AioGetAiSamplingCount(Id, @AiSamplingCount);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioGetAiSamplingCount');    // ErroreTmemo\
      Exit;
    end;
  Label_AiSamplingTimes.Caption := Format('%d', [AiSamplingCount]);

  //Xe[^X̎擾
  Ret := AioGetAiStatus(Id, @AiStatus);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioGetAiStatus');           // ErroreTmemo\
      Exit;
    end;
  Label_AiStatus.Caption := Format('%xH', [AiStatus]);

  Memo_ErrorString.Text := 'ϊԎ擾 : I';
end;

//--------------------------------------------------------------------------------------------------
//   ϊ~
//--------------------------------------------------------------------------------------------------
procedure TForm1.Button_AioStopAiClick(Sender: TObject);
begin
  //ϊ~
  Ret := AioStopAi(Id);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioStopAi');    // ErroreTmemo\
      Exit;
    end;

  Memo_ErrorString.Text := 'ϊ~ : I';
end;

//--------------------------------------------------------------------------------------------------
//  TCart Oto  `l̂ݑΉ
//--------------------------------------------------------------------------------------------------
procedure TForm1.thartout(DatNo:integer);
var
  II: integer;
begin
  if Series1.Count <= 200 then begin              // Ot ݒlȉǉ
    for II := 0 to DatNo -1 do begin
      Series1.AddXY(series1.Count, AiData[II]);   // series1.Count  ADDXYŎIɃJEgAbv
    end;
  end
  else                                            // ݒlzXN[@
  begin
    for II := 0 to Series1.Count - DatNo - 1 do                 // DatNo Vtg
      Series1.YValue[II] := series1.YValue[II + DatNo];
    for II := 0 to DatNo - 1 do                                 // Vf[^[DatNo㏑
      Series1.YValue[II + Series1.Count - DatNo] := AiData[II];
  end;
end;
//--------------------------------------------------------------------------------------------------
//   CxgbZ[W[`
//
//--------------------------------------------------------------------------------------------------
procedure TForm1.MessTest(var Msg: Tmessage);     // Cxg
var
  AiSamplingCount: Longint;
  AiStatus: Longint;
  DataNos : Longint;
begin

  case Msg.Msg of
    //wTvO񐔊i[Cxg
    $1003:
      begin

        Memo_ErrorString.Text := 'wTvOi[CxgAf[^擾';

        //wTvO񐔊i[Cxg񐔂̕\
        inc(AiEventCount);
        Label_Event.Caption := Format('%d', [AiEventCount]);

        //擾TvOf[^i[zTCYȂ悤
        //ł̓`l̂
        DataNos := Msg.lParam;
        if Msg.lParam * AiChannels > DATA_MAX then
          begin
            Msg.lParam := DATA_MAX div AiChannels;
            DataNos := Msg.lParam * AiChannels;
          end;
        //ϊf[^i[pz̃TCY
        SetLength(AiData, DataNos);
        //ϊf[^擾
        Ret := AioGetAiSamplingDataEx(Id, @Msg.lParam, @AiData[0]);
        if Ret <> 0 then
          begin
            ErrorMemoOut('AioGetAiSamplingDataEx');   // ErroreTmemo\
            Exit;
          end;
        thartout(DataNos);                            // Oto
        //擾TvO񐔂̕\
        AiTotalSamplingTimes := AiTotalSamplingTimes + Msg.lParam;
        Label_AiTotalSamplingTimes.Caption := Format('%d', [AiTotalSamplingTimes]);

        //TvO̎擾
        Ret := AioGetAiSamplingCount(Id, @AiSamplingCount);
        if Ret <> 0 then
          begin
            ErrorMemoOut('AioGetAiSamplingCount');    // ErroreTmemo\
            Exit;
          end;
        Label_AiSamplingTimes.Caption := Format('%d', [AiSamplingCount]);

        //Xe[^X̎擾
        Ret := AioGetAiStatus(Id, @AiStatus);
        if Ret <> 0 then
          begin
            ErrorMemoOut('AioGetAiStatus');           // ErroreTmemo\
            Exit;
          end;
        Label_AiStatus.Caption := Format('%xH', [AiStatus]);

        Memo_ErrorString.Text := 'ϊ';
      end;
    //I[o[t[Cxg
    $1004:
      begin
        Memo_ErrorString.Text := 'I[o[t[ɂ~܂';
      end;
    //TvONbNG[Cxg
    $1005:
      begin
        Memo_ErrorString.Text := 'TvONbNG[ɂ~܂';
      end;
    //ADϊG[Cxg
    $1006:
      begin
        Memo_ErrorString.Text := 'ADϊG[ɂ~܂';
      end;
    //ϊICxg
    $1002:
      begin
        // ϊIfoCXɎcf[^[ǂݏo
        Ret := AioGetAiSamplingCount(Id, @AiSamplingCount);
        if Ret <> 0 then
          begin
            ErrorMemoOut('AioGetAiSamplingCount');    // ErroreTmemo\
            Exit;
          end;
        DataNos := AiSamplingCount;
        // ϊIfoCXɃf[^[cĂ
        if DataNos > 0 then begin
          //ϊf[^i[pz̃TCY
          SetLength(AiData, DataNos);
          //ϊf[^擾
          Ret := AioGetAiSamplingDataEx(Id, @DataNos, @AiData[0]);
          if Ret <> 0 then
            begin
              ErrorMemoOut('AioGetAiSamplingDataEx');   // ErroreTmemo\
              Exit;
            end;
          //Oto
          thartout(DataNos);
        end;
        // ϊIfoCXɎcf[^[ǂݏo
        Ret := AioGetAiSamplingCount(Id, @AiSamplingCount);
        if Ret <> 0 then
          begin
            ErrorMemoOut('AioGetAiSamplingCount');    // ErroreTmemo\
            Exit;
          end;
        Label_AiSamplingTimes.Caption := Format('%d', [AiSamplingCount]);
        Memo_ErrorString.Text := 'ϊ~';
      end;
    else
      Msg.Result := DefWindowProc(FWindowHandle, MSg.Msg, MSg.Wparam, MSg.Lparam);
  end;
end;

//--------------------------------------------------------------------------------------------------
//  foCX̏I
//--------------------------------------------------------------------------------------------------
procedure TForm1.Button_AioExitClick(Sender: TObject);
begin
  //foCX̏I
  Ret := AioExit(Id);
  if Ret <> 0 then
    begin
      ErrorMemoOut('AioExit');    // ErroreTmemo\
      Exit;
    end;

  Memo_ErrorString.Text := 'I : I';
end;

//--------------------------------------------------------------------------------------------------
//  tH[̏
//--------------------------------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  //ϊf[^i[pz̃J
  Finalize(AiData);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //擾windowsHandle̔j
  DeallocateHWnd(FWindowHandle);
end;

end.

