unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, VCLTee.TeEngine, VCLTee.Series, Vcl.ExtCtrls, VCLTee.TeeProcs,
  VCLTee.Chart, Vcl.Buttons;

type
  TMainF = class(TForm)
    Button1: TButton;
    Chart1: TChart;
    Series1: TFastLineSeries;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Edit4: TEdit;
    Button2: TButton;
    BitBtn1: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    procedure thartout(DatNo:integer);            // Ot\
    procedure DatWProcd(var Msg: Tmessage);       // bZ[W
  public
    { Public 錾 }
  end;

var
  MainF: TMainF;

  AiData: array of Double;                        // f[^[pz
  F1WindowHandle               : HWND;            // Windows Handle
  DATA_MAX: integer = 20;                         // z̃TCY


implementation

{$R *.dfm}

uses Subdat;

var
  Ecounter                    : integer;          // Cxgs


procedure TMainF.DatWProcd(var Msg: Tmessage);
begin
  with Msg do
    case Msg of
      WM_USER + 1:  begin
                      inc(Ecounter);
                      Edit1.Text := intTostr(Ecounter);   // Cxg\
                      Edit2.Text := intTostr(LParam);     // LParam@C^[o
                      thartout(WParam);                   // WParam@f[^[
                    end;
      else
        Result := DefWindowProc(F1WindowHandle, Msg, WParam, LParam); // WM_USER + 1 ȊȌ
    end;
end;

procedure TMainF.FormCreate(Sender: TObject);
begin
  F1WindowHandle := AllocateHWnd(DatWProcd);      // DatWProcd Handle  
end;

procedure TMainF.FormDestroy(Sender: TObject);
begin
  DeallocateHWnd(F1WindowHandle);                 // WndProcd Handle ̔j
end;

//--------------------------------------------------------------------------------------------------
//  TCart Oto  `l̂ݑΉ
//--------------------------------------------------------------------------------------------------
procedure TMainF.thartout(DatNo:integer);
var
  II: integer;
begin
  if Series1.Count <= 200 then begin              // Ot ݒlȉǉ
    for II := 0 to DatNo -1 do begin
      Series1.AddXY(series1.Count, AiData[II]);   // series1.Count  ADDXYŎIɃJEgAbv
    end;
  end
  else                                            // ݒlzXN[@
  begin
    for II := 0 to Series1.Count - DatNo - 1 do                 // DatNo Vtg
      Series1.YValue[II] := series1.YValue[II + DatNo];
    for II := 0 to DatNo - 1 do                                 // Vf[^[DatNo㏑
      Series1.YValue[II + Series1.Count - DatNo] := AiData[II];
  end;
end;

procedure TMainF.Button1Click(Sender: TObject);
var
  CheckT, Check: integer;
begin
  if mmResult = 0  then begin
      Val(Edit3.Text, DATA_MAX, Check);
      if (DATA_MAX < 1) or (Check <> 0) then exit;
      Val(Edit4.Text, CheckT, Check);
      if (CheckT < 1) or (Check <> 0) then exit;
      SetLength(AiData,DATA_MAX);                       // z̑傫ݒ
      SUBdatF.Edit1.Text := Edit4.Text;                 // ^C}[̎Ԑݒ SUBdatF.Edit1ɏނƂŃ^C}[ݒ
      Series1.Clear;                                    // OtNA
      SUBdatF.TimerStart;                               // MM^C}[X^[g
      Button2.Enabled := False;                         // {^̃fBXGu\eXgp
      Bitbtn1.Enabled := False;                         // {^̃fBXGu\eXgp
    end
    else
    begin
      SUBdatF.TimerStop;                                // MM^C}[Xgbv
      Button2.Enabled := True;                          // {^̃Cl[u\eXgp
      Bitbtn1.Enabled := True;                          // {^̃Cl[u\eXgp
    end;
//  SUBdatF.Show;
end;

end.
