//==============================================================================================
//	API-AIO(WDM)p`t@C																	
//==============================================================================================

unit Caio;

interface

uses
    Windows;

const

//----------------------------------------------------------------------------------------------
//	OM
//----------------------------------------------------------------------------------------------
    AIO_AIF_CLOCK:          SmallInt = 0;  //AiO͊ONbN
    AIO_AIF_START:          SmallInt = 1;  //AiO͊OJngK
    AIO_AIF_STOP:           SmallInt = 2;  //AiO͊O~gK
    AIO_AOF_CLOCK:          SmallInt = 3;  //AiOo͊ONbN
    AIO_AOF_START:          SmallInt = 4;  //AiOo͊OJngK
    AIO_AOF_STOP:           SmallInt = 5;  //AiOo͊O~gK

//----------------------------------------------------------------------------------------------
//	o̓W
//----------------------------------------------------------------------------------------------
    PM10:                SmallInt = 0;    //}10V
    PM5:                 SmallInt = 1;    //}5V
    PM25:                SmallInt = 2;    //}2.5V
    PM125:               SmallInt = 3;    //}1.25V
    PM1:                 SmallInt = 4;    //}1V
    PM0625:              SmallInt = 5;    //}0.625V
    PM05:                SmallInt = 6;    //}0.5V
    PM03125:             SmallInt = 7;    //}0.3125V
    PM025:               SmallInt = 8;    //}0.25V
    PM0125:              SmallInt = 9;    //}0.125V
    PM01:                SmallInt = 10;   //}0.1V
    PM005:               SmallInt = 11;   //}0.05V
    PM0025:              SmallInt = 12;   //}0.025V
    PM00125:             SmallInt = 13;   //}0.0125V
    P10:                 SmallInt = 50;   //0`10V
    P5:                  SmallInt = 51;   //0`5V
    P4095:               SmallInt = 52;   //0`4.095V
    P25:                 SmallInt = 53;   //0`2.5V
    P125:                SmallInt = 54;   //0`1.25V
    P1:                  SmallInt = 55;   //0`1V
    P05:                 SmallInt = 56;   //0`0.5V
    P025:                SmallInt = 57;   //0`0.25V
    P01:                 SmallInt = 58;   //0`0.1V
    P005:                SmallInt = 59;   //0`0.05V
    P0025:               SmallInt = 60;   //0`0.025V
    P00125:              SmallInt = 61;   //0`0.0125V
    P20MA:               SmallInt = 100;  //0`20mA
    P4TO20MA:            SmallInt = 101;  //4`20mA
    P1TO5:               SmallInt = 150;  //1`5V

//----------------------------------------------------------------------------------------------
//	AiO̓Cxg
//----------------------------------------------------------------------------------------------
    AIE_START:      LongInt = $00000002;  //ADϊJnCxg
    AIE_RPTEND:     LongInt = $00000010;  //s[gICxg
    AIE_END:        LongInt = $00000020;  //foCXICxg
    AIE_DATA_NUM:   LongInt = $00000080;  //wTvO񐔊i[Cxg
    AIE_DATA_TSF:   LongInt = $00000100;  //w]Cxg
    AIE_OFERR:      LongInt = $00010000;  //I[o[t[Cxg
    AIE_SCERR:      LongInt = $00020000;  //TvONbNG[Cxg
    AIE_ADERR:      LongInt = $00040000;  //ADϊG[Cxg

//----------------------------------------------------------------------------------------------
//	AiOo̓Cxg
//----------------------------------------------------------------------------------------------
    AOE_START:      LongInt = $00000002;  //DAϊJnCxg
    AOE_RPTEND:     LongInt = $00000010;  //s[gICxg
    AOE_END:        LongInt = $00000020;  //foCXICxg
    AOE_DATA_NUM:   LongInt = $00000080;  //wTvO񐔏o̓Cxg
    AOE_DATA_TSF:   LongInt = $00000100;  //w]Cxg
    AOE_SCERR:      LongInt = $00020000;  //TvONbNG[Cxg
    AOE_DAERR:      LongInt = $00040000;  //DAϊG[Cxg

//----------------------------------------------------------------------------------------------
//	JE^Cxg
//----------------------------------------------------------------------------------------------
    CNTE_DATA_NUM:  LongInt = $00000010;  //rJEgvCxg
    CNTE_ORERR:     LongInt = $00010000;  //JEgI[o[Cxg
    CNTE_ERR:       LongInt = $00020000;  //JE^G[

//----------------------------------------------------------------------------------------------
//	^C}Cxg
//----------------------------------------------------------------------------------------------
    TME_INT:        LongInt = $00000001;  //C^[oCxg

//----------------------------------------------------------------------------------------------
//	AiO̓Xe[^X
//----------------------------------------------------------------------------------------------
    AIS_BUSY:       LongInt = $00000001;  //foCX쒆
    AIS_START_TRG:  LongInt = $00000002;  //JngK҂
    AIS_DATA_NUM:   LongInt = $00000010;  //wTvO񐔊i[
    AIS_OFERR:      LongInt = $00010000;  //I[o[t[
    AIS_SCERR:      LongInt = $00020000;  //TvONbNG[
    AIS_AIERR:      LongInt = $00040000;  //ADϊG[

//----------------------------------------------------------------------------------------------
//	AiOo̓Xe[^X
//----------------------------------------------------------------------------------------------
    AOS_BUSY:       LongInt = $00000001;  //foCX쒆
    AOS_START_TRG:  LongInt = $00000002;  //JngK҂
    AOS_DATA_NUM:   LongInt = $00000010;  //wTvO񐔏o
    AOS_SCERR:      LongInt = $00020000;  //TvONbNG[
    AOS_AOERR:      LongInt = $00040000;  //DAϊG[

//----------------------------------------------------------------------------------------------
//	JE^Xe[^X
//----------------------------------------------------------------------------------------------
    CNTS_BUSY:      LongInt = $00000001;  //JE^쒆
    CNTS_DATA_NUM:  LongInt = $00000010;  //rJEgv
    CNTS_ORERR:     LongInt = $00010000;  //I[o[
    CNTS_ERR:       LongInt = $00020000;  //JE^G[

//----------------------------------------------------------------------------------------------
//	AiO̓bZ[W
//----------------------------------------------------------------------------------------------
    AIOM_AIE_START:     LongInt = $1000;  //ADϊJnCxg
    AIOM_AIE_RPTEND:    LongInt = $1001;  //s[gICxg
    AIOM_AIE_END:       LongInt = $1002;  //foCXICxg
    AIOM_AIE_DATA_NUM:  LongInt = $1003;  //wTvO񐔊i[Cxg
    AIOM_AIE_DATA_TSF:  LongInt = $1007;  //w]Cxg
    AIOM_AIE_OFERR:     LongInt = $1004;  //I[o[t[Cxg
    AIOM_AIE_SCERR:     LongInt = $1005;  //TvONbNG[Cxg
    AIOM_AIE_ADERR:     LongInt = $1006;  //ADϊG[Cxg

//----------------------------------------------------------------------------------------------
//	AiOo̓bZ[W
//----------------------------------------------------------------------------------------------
    AIOM_AOE_START:     LongInt = $1020;  //DAϊJnCxg
    AIOM_AOE_RPTEND:    LongInt = $1021;  //s[gICxg
    AIOM_AOE_END:       LongInt = $1022;  //foCXICxg
    AIOM_AOE_DATA_NUM:  LongInt = $1023;  //wTvO񐔏o̓Cxg
    AIOM_AOE_DATA_TSF:  LongInt = $1027;  //w]Cxg
    AIOM_AOE_SCERR:     LongInt = $1025;  //TvONbNG[Cxg
    AIOM_AOE_ADERR:     LongInt = $1026;  //DAϊG[Cxg

//----------------------------------------------------------------------------------------------
//	JE^bZ[W
//----------------------------------------------------------------------------------------------
    AIOM_CNTE_DATA_NUM: LongInt = $1042;  //rJEgvCxg
    AIOM_CNTE_ORERR:    LongInt = $1043;  //JEgI[o[Cxg
    AIOM_CNTE_ERR:      LongInt = $1044;  //JEgG[Cxg

//----------------------------------------------------------------------------------------------
//	^C}bZ[W
//----------------------------------------------------------------------------------------------
    AIOM_TME_INT:       LongInt = $1060;  //C^[oCxg

//----------------------------------------------------------------------------------------------
//	AiO͓Ytf[^
//----------------------------------------------------------------------------------------------
    AIAT_AI:         LongInt = $00000001;  //AiO͕t
    AIAT_AO0:        LongInt = $00000100;  //AiOo̓f[^
    AIAT_DIO0:       LongInt = $00010000;  //fW^o̓f[^
    AIAT_CNT0:       LongInt = $01000000;  //JE^`lOf[^
    AIAT_CNT1:       LongInt = $02000000;  //JE^`lPf[^

//----------------------------------------------------------------------------------------------
//	JE^샂[h
//----------------------------------------------------------------------------------------------
    CNT_LOADPRESET:        SmallInt = 1;  //vZbgJEgl̃[h
    CNT_LOADCOMP:          SmallInt = 2;  //rJEgl̃[h

//----------------------------------------------------------------------------------------------
//	CxgRg[ڑM
//----------------------------------------------------------------------------------------------
    AIOECU_DEST_AI_CLK:     SmallInt = 4;    //AiO̓TvONbN
    AIOECU_DEST_AI_START:   SmallInt = 0;    //AiO͕ϊJnM
    AIOECU_DEST_AI_STOP:    SmallInt = 2;    //AiO͕ϊ~M
    AIOECU_DEST_AO_CLK:     SmallInt = 36;   //AiOo̓TvONbN
    AIOECU_DEST_AO_START:   SmallInt = 32;   //AiOo͕ϊJnM
    AIOECU_DEST_AO_STOP:    SmallInt = 34;   //AiOo͕ϊ~M
    AIOECU_DEST_CNT0_UPCLK: SmallInt = 134;  //JE^OAbvNbNM
    AIOECU_DEST_CNT1_UPCLK: SmallInt = 135;  //JE^PAbvNbNM
    AIOECU_DEST_CNT0_START: SmallInt = 128;  //JE^OA^C}OJnM
    AIOECU_DEST_CNT1_START: SmallInt = 129;  //JE^PA^C}PJnM
    AIOECU_DEST_CNT0_STOP:  SmallInt = 130;  //JE^OA^C}O~M
    AIOECU_DEST_CNT1_STOP:  SmallInt = 131;  //JE^PA^C}P~M
    AIOECU_DEST_MASTER1:    SmallInt = 104;  //oX}X^MP
    AIOECU_DEST_MASTER2:    SmallInt = 105;  //oX}X^MQ
    AIOECU_DEST_MASTER3:    SmallInt = 106;  //oX}X^MR

//----------------------------------------------------------------------------------------------
//	CxgRg[ڑM
//----------------------------------------------------------------------------------------------
    AIOECU_SRC_OPEN:         SmallInt = -1;   //ڑ
    AIOECU_SRC_AI_CLK:       SmallInt = 4;    //AiO͓NbNM
    AIOECU_SRC_AI_EXTCLK:    SmallInt = 146;  //AiO͊ONbNM
    AIOECU_SRC_AI_TRGSTART:  SmallInt = 144;  //AiO͊OgKJnM
    AIOECU_SRC_AI_LVSTART:   SmallInt = 28;   //AiO̓xgKJnM
    AIOECU_SRC_AI_STOP:      SmallInt = 17;   //AiO͕ϊ񐔏IMixȂj
    AIOECU_SRC_AI_STOP_DELAY:SmallInt = 18;   //AiO͕ϊ񐔏IMixj
    AIOECU_SRC_AI_LVSTOP:    SmallInt = 29;   //AiO̓xgK~M
    AIOECU_SRC_AI_TRGSTOP:   SmallInt = 145;  //AiO͊OgK~M
    AIOECU_SRC_AO_CLK:       SmallInt = 66;   //AiOo͓NbNM
    AIOECU_SRC_AO_EXTCLK:    SmallInt = 149;  //AiOo͊ONbNM
    AIOECU_SRC_AO_TRGSTART:  SmallInt = 147;  //AiOo͊OgKJnM
    AIOECU_SRC_AO_STOP_FIFO: SmallInt = 352;  //AiOo͎w񐔏o͏IMiFIFOgpj
    AIOECU_SRC_AO_STOP_RING: SmallInt = 80;   //AiOo͎w񐔏o͏IMiRINGgpj
    AIOECU_SRC_AO_TRGSTOP:   SmallInt = 148;  //AiOo͊OgK~M
    AIOECU_SRC_CNT0_UPCLK:   SmallInt = 150;  //JE^OAbvNbNM
    AIOECU_SRC_CNT1_UPCLK:   SmallInt = 152;  //JE^PAbvNbNM
    AIOECU_SRC_CNT0_CMP:     SmallInt = 288;  //JE^OrJEgv
    AIOECU_SRC_CNT1_CMP:     SmallInt = 289;  //JE^PrJEgv
    AIOECU_SRC_SLAVE1:       SmallInt = 136;  //oXX[uMP
    AIOECU_SRC_SLAVE2:       SmallInt = 137;  //oXX[uMQ
    AIOECU_SRC_SLAVE3:       SmallInt = 138;  //oXX[uMR
    AIOECU_SRC_START:        SmallInt = 384;  //Ai, Ao, Cnt, Tm\tgEFAJnM
    AIOECU_SRC_STOP:         SmallInt = 385;  //Ai, Ao, Cnt, Tm\tgEFA~M

//----------------------------------------------------------------------------------------------
//	֐vg^Cv
//----------------------------------------------------------------------------------------------
//ʊ֐
function    AioInit(DeviceName:PansiChar; Id:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioExit(Id:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioResetDevice(Id:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetErrorString(Id:SmallInt; ErrorString:PansiChar):LongInt;stdcall;external 'caio.dll';
function    AioQueryDeviceName(Index:SmallInt; DeviceName:PansiChar; Device:PansiChar):LongInt;stdcall;external 'caio.dll';
function    AioGetDeviceType(Device:PansiChar; DeviceType:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetControlFilter(Id:SmallInt; Signal:SmallInt; Value:Single):LongInt;stdcall;external 'caio.dll';
function    AioGetControlFilter(Id:SmallInt; Signal:SmallInt; Value:PSingle):LongInt;stdcall;external 'caio.dll';

//AiO͊֐
function    AioSingleAi(Id:SmallInt; AiChannel:SmallInt; AiData:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSingleAiEx(Id:SmallInt; AiChannel:SmallInt; AiData:PSingle):LongInt;stdcall;external 'caio.dll';
function    AioMultiAi(Id:SmallInt; AiChannels:SmallInt; AiData:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioMultiAiEx(Id:SmallInt; AiChannels:SmallInt; AiData:PSingle):LongInt;stdcall;external 'caio.dll';
function    AioGetAiResolution(Id:SmallInt; AiResolution:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiInputMethod(Id:SmallInt; AiInputMethod:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiInputMethod(Id:SmallInt; AiInputMethod:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiMaxChannels(Id:SmallInt; AiMaxChannels:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiChannels(Id:SmallInt; AiChannels:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiChannels(Id:SmallInt; AiChannels:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiChannelSequence(Id:SmallInt; AiSequence:SmallInt; AiChannel:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiChannelSequence(Id:SmallInt; AiSequence:SmallInt; AiChannel:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiRange(Id:SmallInt; AiChannel: SmallInt; AiRange:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiRangeAll(Id:SmallInt; AiRange:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiRange(Id:SmallInt; AiChannel: SmallInt; AiRange:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiTransferMode(Id:SmallInt; AiTransferMode:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiTransferMode(Id:SmallInt; AiTransferMode:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiTransferData(Id:SmallInt; DataNumber:LongInt; Buffer:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiAttachedData(Id:SmallInt; AttachedData:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiSamplingDataSize(Id:SmallInt; DataSize:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiMemoryType(Id:SmallInt; AiMemoryType:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiMemoryType(Id:SmallInt; AiMemoryType:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiRepeatTimes(Id:SmallInt; AiRepeatTimes:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiRepeatTimes(Id:SmallInt; AiRepeatTimes:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiClockType(Id:SmallInt; AiClockType:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiClockType(Id:SmallInt; AiClockType:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiSamplingClock(Id:SmallInt; AiSamplingClock:Single):LongInt;stdcall;external 'caio.dll';
function    AioGetAiSamplingClock(Id:SmallInt; AiSamplingClock:PSingle):LongInt;stdcall;external 'caio.dll';
function    AioSetAiScanClock(Id:SmallInt; AiScanClock:Single):LongInt;stdcall;external 'caio.dll';
function    AioGetAiScanClock(Id:SmallInt; AiScanClock:PSingle):LongInt;stdcall;external 'caio.dll';
function    AioSetAiClockEdge(Id:SmallInt; AiClockEdge:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiClockEdge(Id:SmallInt; AiClockEdge:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiStartTrigger(Id:SmallInt; AiStartTrigger:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStartTrigger(Id:SmallInt; AiStartTrigger:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiStartLevel(Id:SmallInt; AiChannel:SmallInt; AiStartLevel:LongInt; AiDirection:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiStartLevelEx(Id:SmallInt; AiChannel:SmallInt; AiStartLevel:Single; AiDirection:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStartLevel(Id:SmallInt; AiChannel:SmallInt; AiStartLevel:PLongInt; AiDirection:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStartLevelEx(Id:SmallInt; AiChannel:SmallInt; AiStartLevel:PSingle; AiDirection:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiStartInRange(Id:SmallInt; AiChannel:SmallInt; Level1:LongInt; Level2:LongInt; StateTimes:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStartInRange(Id:SmallInt; AiChannel:SmallInt; Level1:PLongInt; Level2:PLongInt; StateTimes:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiStartOutRange(Id:SmallInt; AiChannel:SmallInt; Level1:LongInt; Level2:LongInt; StateTimes:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStartOutRange(Id:SmallInt; AiChannel:SmallInt; Level1:PLongInt; Level2:PLongInt; StateTimes:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiStopTrigger(Id:SmallInt; AiStopTrigger:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStopTrigger(Id:SmallInt; AiStopTrigger:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiStopTimes(Id:SmallInt; AiStopTimes:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStopTimes(Id:SmallInt; AiStopTimes:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiStopLevel(Id:SmallInt; AiChannel:SmallInt; AiStopLevel:LongInt; AiDirection:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiStopLevelEx(Id:SmallInt; AiChannel:SmallInt; AiStopLevel:Single; AiDirection:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStopLevel(Id:SmallInt; AiChannel:SmallInt; AiStopLevel:PLongInt; AiDirection:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStopLevelEx(Id:SmallInt; AiChannel:SmallInt; AiStopLevel:PSingle; AiDirection:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiStopInRange(Id:SmallInt; AiChannel:SmallInt; Level1:LongInt; Level2:LongInt; StateTimes:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStopInRange(Id:SmallInt; AiChannel:SmallInt; Level1:PLongInt; Level2:PLongInt; StateTimes:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiStopOutRange(Id:SmallInt; AiChannel:SmallInt; Level1:LongInt; Level2:LongInt; StateTimes:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStopOutRange(Id:SmallInt; AiChannel:SmallInt; Level1:PLongInt; Level2:PLongInt; StateTimes:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiStopDelayTimes(Id:SmallInt; AiStopDelayTimes:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStopDelayTimes(Id:SmallInt; AiStopDelayTimes:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiEvent(Id:SmallInt; hWnd:THandle; AiEvent:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiEvent(Id:SmallInt; hWnd:PHandle; AiEvent:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiCallBackProc(Id:SmallInt; pProc:Pointer; AiEvent:LongInt; Param:Pointer):LongInt;stdcall;external 'caio.dll';
function    AioSetAiEventSamplingTimes(Id:SmallInt; AiSamplingTimes:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiEventSamplingTimes(Id:SmallInt; AiSamplingTimes:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAiEventTransferTimes(Id:SmallInt; AiTransferTimes:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiEventTransferTimes(Id:SmallInt; AiTransferTimes:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioStartAi(Id:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioStopAi(Id:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStatus(Id:SmallInt; AiStatus:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiSamplingCount(Id:SmallInt; AiSamplingCount:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStopTriggerCount(Id:SmallInt; AiStopTriggerCount:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiTransferCount(Id:SmallInt; AiTransferCount:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiTransferLap(Id:SmallInt; Lap:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiRepeatCount(Id:SmallInt; AiRepeatCount:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiStopTriggerTransferCount(Id:SmallInt; Count:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiSamplingData(Id:SmallInt; AiSamplingTimes:PLongInt; AiData:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAiSamplingDataEx(Id:SmallInt; AiSamplingTimes:PLongInt; AiData:PSingle):LongInt;stdcall;external 'caio.dll';
function    AioResetAiStatus(Id:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioResetAiMemory(Id:SmallInt):LongInt;stdcall;external 'caio.dll';

//AiOo͊֐
function    AioSingleAo(Id:SmallInt; AoChannel:SmallInt; AoData:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioSingleAoEx(Id:SmallInt; AoChannel:SmallInt; AoData:Single):LongInt;stdcall;external 'caio.dll';
function    AioMultiAo(Id:SmallInt; AoChannels:SmallInt; AoData:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioMultiAoEx(Id:SmallInt; AoChannels:SmallInt; AoData:PSingle):LongInt;stdcall;external 'caio.dll';
function    AioGetAoResolution(Id:SmallInt; AoResolution:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoChannels(Id:SmallInt; AoChannels:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoChannels(Id:SmallInt; AoChannels:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoMaxChannels(Id:SmallInt; AoMaxChannels:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoRange(Id:SmallInt; AoChannel:SmallInt; AoRange:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoRangeAll(Id:SmallInt; AoRange:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoRange(Id:SmallInt; AoChannel:SmallInt; AoRange:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoTransferMode(Id:SmallInt; AoTransferMode:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoTransferMode(Id:SmallInt; AoTransferMode:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoTransferData(Id:SmallInt; DataNumber:LongInt; Buffer:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoSamplingDataSize(Id:SmallInt; DataSize:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoMemoryType(Id:SmallInt; AoMemoryType:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoMemoryType(Id:SmallInt; AoMemoryType:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoRepeatTimes(Id:SmallInt; AoRepeatTimes:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoRepeatTimes(Id:SmallInt; AoRepeatTimes:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoClockType(Id:SmallInt; AoClockType:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoClockType(Id:SmallInt; AoClockType:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoSamplingClock(Id:SmallInt; AoSamplingClock:Single):LongInt;stdcall;external 'caio.dll';
function    AioGetAoSamplingClock(Id:SmallInt; AoSamplingClock:PSingle):LongInt;stdcall;external 'caio.dll';
function    AioSetAoClockEdge(Id:SmallInt; AoClockEdge:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoClockEdge(Id:SmallInt; AoClockEdge:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoSamplingData(Id:SmallInt; AoSamplingTimes:LongInt; AoData:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoSamplingDataEx(Id:SmallInt; AoSamplingTimes:LongInt; AoData:PSingle):LongInt;stdcall;external 'caio.dll';
function    AioGetAoSamplingTimes(Id:SmallInt; AoSamplingTimes:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoStartTrigger(Id:SmallInt; AoStartTrigger:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoStartTrigger(Id:SmallInt; AoStartTrigger:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoStopTrigger(Id:SmallInt; AoStopTrigger:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoStopTrigger(Id:SmallInt; AoStopTrigger:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoEvent(Id:SmallInt; hWnd:THandle; AoEvent:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoEvent(Id:SmallInt; hWnd:PHandle; AoEvent:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoCallBackProc(Id:SmallInt; pProc:Pointer; AoEvent:LongInt; Param:Pointer):LongInt;stdcall;external 'caio.dll';
function    AioSetAoEventSamplingTimes(Id:SmallInt; AoSamplingTimes:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoEventSamplingTimes(Id:SmallInt; AoSamplingTimes:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetAoEventTransferTimes(Id:SmallInt; AoTransferTimes:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoEventTransferTimes(Id:SmallInt; AoTransferTimes:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioStartAo(Id:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioStopAo(Id:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioEnableAo(Id:SmallInt; AoChannel:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioDisableAo(Id:SmallInt; AoChannel:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoStatus(Id:SmallInt; AoStatus:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoSamplingCount(Id:SmallInt; AoSamplingCount:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoTransferCount(Id:SmallInt; AoTransferCount:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoTransferLap(Id:SmallInt; Lap:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetAoRepeatCount(Id:SmallInt; AoRepeatCount:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioResetAoStatus(Id:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioResetAoMemory(Id:SmallInt):LongInt;stdcall;external 'caio.dll';

//fW^o͊֐
function    AioSetDiFilter(Id:SmallInt; Bit:SmallInt; Value:Single):LongInt;stdcall;external 'caio.dll';
function    AioGetDiFilter(Id:SmallInt; Bit:SmallInt; Value:PSingle):LongInt;stdcall;external 'caio.dll';
function    AioInputDiBit(Id:SmallInt; DiBit:SmallInt; DiData:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioOutputDoBit(Id:SmallInt; DoBit:SmallInt; DoData:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioInputDiByte(Id:SmallInt; DiPort:SmallInt; DiData:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioOutputDoByte(Id:SmallInt; DoPort:SmallInt; DoData:SmallInt):LongInt;stdcall;external 'caio.dll';

//JE^֐
function    AioGetCntMaxChannels(Id:SmallInt; CntMaxChannels:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetCntComparisonMode(Id:SmallInt; CntChannel:SmallInt; CntMode:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetCntComparisonMode(Id:SmallInt; CntChannel:SmallInt; CntMode:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetCntPresetReg(Id:SmallInt; CntChannel:SmallInt; PresetNumber:LongInt; PresetData:PLongInt; Flag:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetCntComparisonReg(Id:SmallInt; CntChannel:SmallInt; ComparisonNumber:LongInt; ComparisonData:PLongInt; Flag:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetCntInputSignal(Id:SmallInt; CntChannel:SmallInt; CntInputSignal:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetCntInputSignal(Id:SmallInt; CntChannel:SmallInt; CntInputSignal:PSmallInt):LongInt;stdcall;external 'caio.dll';
function    AioSetCntEvent(Id:SmallInt; CntChannel:SmallInt; hWnd:THandle; CntEvent:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetCntEvent(Id:SmallInt; CntChannel:SmallInt; hWnd:PHandle; CntEvent:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetCntCallBackProc(Id:SmallInt; CntChannel:SmallInt; pProc:Pointer; CntEvent:longInt; Param:Pointer):LongInt;stdcall;external 'caio.dll';
function    AioSetCntFilter(Id:SmallInt; CntChannel:SmallInt; Signal:SmallInt; Value:Single):LongInt;stdcall;external 'caio.dll';
function    AioGetCntFilter(Id:SmallInt; CntChannel:SmallInt; Signal:SmallInt; Value:PSingle):LongInt;stdcall;external 'caio.dll';
function    AioStartCnt(Id:SmallInt; CntChannel:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioStopCnt(Id:SmallInt; CntChannel:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioPresetCnt(Id:SmallInt; CntChannel:SmallInt; PresetData:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetCntStatus(Id:SmallInt; CntChannel:SmallInt; CntStatus:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetCntCount(Id:SmallInt; CntChannel:SmallInt; Count:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioResetCntStatus(Id:SmallInt; CntChannel:SmallInt; CntStatus:LongInt):LongInt;stdcall;external 'caio.dll';

//^C}֐
function    AioSetTmEvent(Id:SmallInt; TimerId:SmallInt; hWnd:THandle; TmEvent:LongInt):LongInt;stdcall;external 'caio.dll';
function    AioGetTmEvent(Id:SmallInt; TimerId:SmallInt; hWnd:PHandle; TmEvent:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioSetTmCallBackProc(Id:SmallInt; TimerId:SmallInt; pProc:Pointer; TmEvent:LongInt; Param:Pointer):LongInt;stdcall;external 'caio.dll';
function    AioStartTmTimer(Id:SmallInt; TimerId:SmallInt; Interval:Single):LongInt;stdcall;external 'caio.dll';
function    AioStopTmTimer(Id:SmallInt; TimerId:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioStartTmCount(Id:SmallInt; TimerId:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioStopTmCount(Id:SmallInt; TimerId:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioLapTmCount(Id:SmallInt; TimerId:SmallInt; Lap:PLongInt):LongInt;stdcall;external 'caio.dll';
function    AioResetTmCount(Id:SmallInt; TimerId:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioTmWait(Id:SmallInt; TimerId:SmallInt; Wait:LongInt):LongInt;stdcall;external 'caio.dll';

//CxgRg[
function    AioSetEcuSignal(Id:SmallInt; Destination:SmallInt; Source:SmallInt):LongInt;stdcall;external 'caio.dll';
function    AioGetEcuSignal(Id:SmallInt; Destination:SmallInt; Source:PSmallInt):LongInt;stdcall;external 'caio.dll';

implementation

end.

