unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, System.Types,
  Dialogs, ExtCtrls, StdCtrls, StopWatch, MMTimer,
  Buttons, WPRCMMTimer, Menus, MMSystem, OleCtrls, VCLTee.Series, VCLTee.TeEngine, VCLTee.TeeProcs, VCLTee.Chart;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Timer1: TTimer;
    StopWatch1: TStopWatch;
    Edit3: TEdit;
    Button2: TButton;
    MMTimer1: TMMTimer;
    BitBtn1: TBitBtn;
    WPRCMMTimer1: TWPRCMMTimer;
    BitBtn2: TBitBtn;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    test1: TMenuItem;
    Edit4: TEdit;
    GroupBox1: TGroupBox;
    Button3: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    Label1: TLabel;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Chart1: TChart;
    Series1: TFastLineSeries;
    Series2: TPointSeries;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    StopWatch2: TStopWatch;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure MMTimer1Timer(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure WPRCMMTimer1Timer(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure test1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure Chart1AfterDraw(Sender: TObject);
  private
    { Private 錾 }
    FWindowHandle:HWND;                       // WndProcd Handle
    SendMessF: Boolean;                       // SendMessstO
    TMinMax: TIMECAPS;
    procedure WndProcd(var Msg:TMessage);             // TChart@sI^[h~
    Procedure WMSysCommand(var Messages: TWMSysCommand);message WM_SysCommand;
    procedure Timersub(DS: integer);
    procedure Cpuinfo;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;
  T:  Extended;
  MMPeriodF: Boolean;           // timeBeginPeriod set Flag
  MMMin: Cardinal;              // MMTime ŏl

implementation

{$R *.dfm}
const
  AdataMax = 20;
  GraphMax = 200;

var
  X           : double = 0;                     // Xf[^[
  TbeginF     : Boolean;                        // vONOtOnAfterDrawLZp
  CheckBoxF   : Boolean;                        // XŒ蒷`FbN{bNXtO
  AData       : array[0..AdataMax] of double;   // Data obt@pz
  DataNo      : integer;                        // zԍ
  MMX : integer;                                // Xf[^[ԍ
  vMaskProcess, vMaskSystem : DWORD_PTR;        // Void ^ Cpu
  KLM         : integer;                        // Op`f[^[쐬p


Procedure TForm1.WMSysCommand(var Messages: TWMSysCommand); // VXebZ[W
begin
  case (messages.CmdType and $FFF0) of
    SC_SIZE : Messages.Result := 0;                         // TCYύXȂ
    SC_MOVE : Messages.Result := 0;                         // ړȂ
  else
    inherited;                                              // LȊOftHg
  end;
end;

procedure TForm1.Chart1AfterDraw(Sender: TObject);          // Graf\㊄荞݂ō}
var
  Y1,Y2: integer;
  Pos1, Pos2: TPoint;
begin
  if not TbeginF then exit;                                 // Ot\JnOI
  if CheckBox12.Checked then begin                          // \璆Ԑ\
    Y1 := Chart1.ChartRect.Top;
    Y2 := Chart1.ChartRect.Bottom;
    Pos1 := point(integer(Series1.CalcXPosValue(Series1.MaxXValue / 2)), Y1);
    Pos2 := point(integer(Series1.CalcXPosValue(Series1.MaxXValue / 2)), Y2);
    Chart1.Canvas.Pen.Color := clBlue;
    Chart1.Canvas.MoveTo(Pos1.X,Pos1.Y);
    Chart1.Canvas.LineTo(Pos2.X,Pos2.Y);
  end;
  canvas.TextOut(5,10,'Timer ' + floatTostrF(T,ffFixed,7,4) + '               ');
  canvas.TextOut(5,30,'Chart ' + floatTostrF(stopwatch2.Stop,ffFixed,7,4) + '               '); // Ot}ԕ\
  edit3.Text := floatTostrF(T,ffFixed,10,4);                                          // ^C}[ԕ\
  edit3.Update;                                                                       // ꂪȂƃ^C}[ԒZ\XVȂ
end;

procedure TForm1.Cpuinfo;                                                  // Cpu̐擾ƕ\
var
  Cp : Tcomponent;
  JJ : integer;
  nn : Cardinal;
begin
  GetProcessAffinityMask(GetCurrentProcess, vMaskProcess, vMaskSystem);    // Cpu̐擾
  case vMaskSystem of                                                      // Cpu RA̐\
    1: Label1.Caption := 'Cpu̐@1';
    3: Label1.Caption := 'Cpu̐@2';
    7: Label1.Caption := 'Cpu̐@3';
   15: Label1.Caption := 'Cpu̐@4';
   31: Label1.Caption := 'Cpu̐@5';
   63: Label1.Caption := 'Cpu̐@6';
  127: Label1.Caption := 'Cpu̐@7';
  255: Label1.Caption := 'Cpu̐@8';
  end;
  nn := 1;
  for JJ := 1 to 8 do
    begin
      Cp := Findcomponent('Checkbox' + intTostr(JJ));       // Checkbox1`8
      TCheckbox(CP).Tag := nn;                              // tagCPU@rbgtOZbg
      if vMaskSystem and nn = nn then TCheckbox(CP).Enabled := True   // `FbN{bNXCl[uZbg
                                 else
                                 begin                                // RA
                                      TCheckbox(CP).Enabled := False;
                                      TCheckbox(CP).Checked := False;
                                 end;
      nn := nn * 2;                                         // 1,2,4,8 ` 128
    end;
  Label2.Caption := '';                                               // gpx\
end;

procedure TForm1.Button1Click(Sender: TObject);             // ^C}[~ƃOt
var
  II: integer;
  Y : double;
begin
  TbeginF := True;                                          // OnAfterDraw 
  stopwatch1.Stop;
  stopwatch2.Stop;
  Chart1.LeftAxis.Automatic := True;
  Chart1.BottomAxis.Automatic := True;
  if WPRCMMTimer1.Enabled then WPRCMMTimer1.Enabled := False;
  if MMTimer1.Enabled then MMTimer1.Enabled := False;
  if Timer1.Enabled then Timer1.Enabled := False;
  stopwatch2.Start;
  Series1.Clear;                                            // OtP
  Series2.Clear;                                            // OtQ
  for II := 0 to 20 do                                      // 荇QO\
    begin
      Y := Random(100) / 3.3;
      Series1.AddXY(II, Y);
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);             // Timer1 X^[g@Xgbv
var
  ch,T: integer;
begin
  TbeginF := True;                                          // OnAfterDraw 
  if CheckBox12.Checked then begin                          // \
    Chart1.LeftAxis.Visible := True;
    Chart1.BottomAxis.Visible := True;
  end
  else                                                      // \
  begin
    Chart1.LeftAxis.Visible := False;
    Chart1.BottomAxis.Visible := False;
  end;
  stopwatch2.Stop;
  stopwatch1.Stop;
  Chart1.LeftAxis.Automatic := True;                        // Y
  Chart1.BottomAxis.Automatic := True;                      // x
  Val(Edit4.Text,T,ch);                                     // ^C}[Ԑlϊ
  if (ch = 0) and (T > 0) then Timer1.Interval := T;            // ^C}[ԃZbg
  if WPRCMMTimer1.Enabled then WPRCMMTimer1.Enabled := False;
  if MMTimer1.Enabled then MMTimer1.Enabled := False;
  if Timer1.Enabled then                      // ^C}[X^[g~gO
    begin
      Timer1.Enabled := False;
      Button3.Enabled := True;
    end
    else
    begin
      X := 0;
      Series1.Clear;
      Series2.Clear;
      Button3.Enabled := False;
      Timer1.Enabled := True;
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);             // gpCpu RÃZbg
var
  Cpufrg  : integer;
  Cp      : Tcomponent;
  JJ      : integer;
  nn      : Cardinal;
  Ret     : Boolean;
begin                                                       // cpu0 cpu1 cpu2 cpu3 cpu4 cpu5 cpu6 cpu7
  Cpufrg := 0;
  for JJ := 1 to 8 do                                       // RA̐܂œ̓`FbN
    begin
      Cp := Findcomponent('Checkbox' + intTostr(JJ));       // Checkbox1`8
      if TCheckbox(Cp).Checked then Cpufrg := Cpufrg or TCheckbox(Cp).Tag;  // `FbN̗Lꏊ̃tOZbg
    end;
  if Cpufrg = 0 then Cpufrg := vMaskSystem;                 // ɂ`FbNSĂCPU
  Ret := SetProcessAffinityMask(GetCurrentProcess, Cpufrg);         // gpRÃZbg  1, 2, 4, 8, 16, 32, 64, 128
  if Ret then
    begin
      Ret := GetProcessAffinityMask(GetCurrentProcess, vMaskProcess, vMaskSystem);  // Zbgꂽ̊mF
      if Ret then
        begin
          nn := 1;                                                  // CpurbgtO
          label2.Caption := 'gpCPU ';
          for JJ := 0 to 7 do                                       // W̃Zbgԕ\
            begin
              if vMaskProcess and nn = nn then label2.Caption := label2.Caption + '  ' + intTostr(JJ);
              nn := nn * 2;                                         // 1,2,4,8,16,32,64,128
            end;
        end
        else
          label2.Caption := 'gpCPU 擾s';
    end
    else
      label2.Caption := 'gpCPU w莸s';
end;

procedure TForm1.test1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);       // MMtimer start stop
var
  ch, T: integer;
begin
  TbeginF := True;                                    // OnAfterDraw 
  if CheckBox12.Checked then begin                    // ̕\w肾
    Chart1.LeftAxis.Visible := True;
    Chart1.BottomAxis.Visible := True;
  end
  else                                                // \
  begin
    Chart1.LeftAxis.Visible := False;
    Chart1.BottomAxis.Visible := False;
  end;
  stopwatch2.Stop;
  stopwatch1.Stop;
  CheckBoxF := CheckBox10.Checked;                    // Œ蒷
  if CheckBoxF then                                   // Œ蒷
    begin
      Chart1.LeftAxis.Automatic := False;
      Chart1.LeftAxis.Maximum := 10;
      Chart1.LeftAxis.Minimum := 3;
      Chart1.BottomAxis.Automatic := False;
      Chart1.BottomAxis.Maximum := GraphMax;
      Chart1.BottomAxis.Minimum := 0;
    end
    else                                              // I[gw肾
    begin
      Chart1.LeftAxis.Automatic := True;
      Chart1.BottomAxis.Automatic := True;
    end;
  Val(Edit4.Text,T,ch);                               // ^C}[
  if WPRCMMTimer1.Enabled then WPRCMMTimer1.Enabled := False;
  if Timer1.Enabled then Timer1.Enabled := False;
  if MMTimer1.Enabled then
    begin
      MMTimer1.Enabled := False;
      Button3.Enabled := True;
    end
    else
    begin
      if (ch = 0) and (T > 0) then MMTimer1.Interval := T;          // ^C}[ԃZbg
      X := 0;
      DataNo := 0;
      MMX := 0;
      Series1.Clear;
      Series2.Clear;                                  // ^C}[X^[g
      Button3.Enabled := False;
      MMTimer1.Enabled := True;
    end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);       // WPRCTimer
var
  ch,T: integer;
begin
  TbeginF := True;                                    // OnAfterDraw 
  if CheckBox12.Checked then begin                    // ̕\w肾
    Chart1.LeftAxis.Visible := True;
    Chart1.BottomAxis.Visible := True;
  end
  else                                                // \
  begin
    Chart1.LeftAxis.Visible := False;
    Chart1.BottomAxis.Visible := False;
  end;
  stopwatch2.Stop;
  stopwatch1.Stop;
  Chart1.LeftAxis.Automatic := True;                  // YI[g
  Chart1.BottomAxis.Automatic := True;                // XI[g
  Val(Edit4.Text,T,ch);
  if (ch = 0) and (T >0) then WPRCMMTimer1.Interval := T;  // ^C}[ԃZbg
  if Timer1.Enabled then Timer1.Enabled := False;
  if MMTimer1.Enabled then MMTimer1.Enabled := False;
  if WPRCMMTimer1.Enabled then
    begin
      WPRCMMTimer1.Enabled := False;                  // ^C}[~
      Button3.Enabled := True;                        // Cpu RAw{^Cl[u
    end
    else
    begin
      X := 0;                                         // XplNA
      Series1.Clear;                                  // Series1OtNA
      Series2.Clear;                                  // Series2OtNA
      Button3.Enabled := False;                       // Cpu RAw{^fBXGu
      WPRCMMTimer1.Enabled := True;                   // ^C}[X^[g
    end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if MMPeriodF then timeEndPeriod(MMMin);             // MMTIME̍ŏlݒ肳Ă
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  Timer1.Enabled := False;
  MMTimer1.Enabled := False;
  WPRCMMTimer1.Enabled := False;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FWindowHandle := Classes.AllocateHWnd(WndProcd);  // WndProcd Handle  
  if FWindowHandle > 0 then  SendMessF := True;     // WndProcd Handle擾ł
  Edit3.Text := '';
  Edit4.Text := '20';
  TimeGetDevCaps(@TMinMax,sizeof(TMinMax));         // MMTIM̎dl擾
  MMMin := TMinMax.wPeriodMin;                      // ŏl̎擾
  if timeBeginPeriod(MMMin) = 0 then MMPeriodF := true; // MMTIME̍ŏlݒłTrue Delayp
  Cpuinfo;                                          // CPU̐\
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Classes.DeallocateHWnd(FWindowHandle);            // WndProcd Handle ̔j
end;

procedure TForm1.Timersub(DS: integer);             // Ot\[`
var
  Y1: double;
  II: integer;
begin
  if X > 2000 then                                  // X2000zOtNA
    begin
      X := 0;
      Series1.Clear;
      Series2.Clear;
      exit;
    end;
  Y1 := AData[DS];                                  // z񂩂f[^[ǂݏo
  stopwatch2.Start;                                 // OtݎԑpXgbvEHb`X^[g
  if CheckBoxF then begin                           // XŒw肾
    if Series1.Count <= GraphMax then                    // X200ȉ
      begin
        Series1.AddXY(X, Y1);                       // Otǉ
        X := X + 1;                                 // XCNg
      end
      else                                          // XŒłȂ
      begin
        if not CheckBox11.Checked then begin        // XXN[włȂ
          Series1.YValue[MMX] := Y1;                // XOtzɃf[^[Zbg
          inc(MMX);                                 // zԍCNg
          if MMX > GraphMax then MMX := 0;                  // 200z[ɖ߂
        end
        else begin                                          // XN[w肾
          for II := 0 to GraphMax - 1 do                    // XOtz̃f[^[Vtg
             Series1.YValue[II] := Series1.YValue[II + 1];
          Series1.YValue[GraphMax] := Y1;                   // 擪ɐVlZbg
        end;
      end;
  end
  else                                                      // XŒłȂ
  begin
    Series1.AddXY(X, Y1);                                   // f[^[Otɒǉ
    X := X + 1;                                             // XCNg
  end;
  if Checkbox9.Checked then                                 // Series2 \w肾
    if (X > 1000) and (2000 - X > 0) then                   // X̒l 1000 2000@
      Series2.AddXY(2000 - X, Y1);                          // Otǉ
end;

procedure TForm1.WndProcd(var Msg:TMessage);        // MMtimer bZ[W
begin
  with Msg do
    case Msg of
      WM_USER:  try
                  Timersub(WPARAM);                       // ^C}[[`
                except
                  Application.HandleException(Self);
                end;
      else
        Result := DefWindowProc(FWindowHandle, Msg, WParam, LParam);
    end;
end;

procedure TForm1.MMTimer1Timer(Sender: TObject);    // MMTimer ł zgpAzɃf[^[Zbg
begin                                               // zԍ|XgbZ[Wő
  Adata[DataNo] :=  KLM / 10 + 4;                   // f[^[쐬 Opg zɓ
  inc(KLM);
  if KLM > 50 then KLM := 0;
  if SendMessF then                                 // nhĂ
    PostMessage(FWindowHandle, WM_USER, DataNo, 0); // |XgbZ[WMzԍnBɐ䂪߂
  inc(DataNo);                                      // zԍCNg
  if DataNo > AdataMax then DataNo := 0;            // zԍ̍őlz[ɖ߂
  T := stopwatch1.Stop;                             // ^C}[ԑpXgbvEHb`~Ԏ擾
  stopwatch1.Start;                                 // ^C}[ԑpXgbvEHb`Jn
end;

procedure TForm1.WPRCMMTimer1Timer(Sender: TObject);
var
  Y1: double;
begin
  T := stopwatch1.Stop;                             // ^C}[ԑpXgbvEHb`~Ԏ擾
  stopwatch1.Start;                                 // ^C}[ԑpXgbvEHb`Jn
  if X > 2000 then                                  // X2000zOtNA
    begin
      X := 0;
      Series1.Clear;
      Series2.Clear;
      exit;
    end;
  Y1 := Random(50) / 3.3 + 0.1;                     // f[^[쐬
  stopwatch2.Start;                                 // Oto͎ԑpJn
  Series1.AddXY(X, Y1);                             // Otɒǉ
  if Checkbox9.Checked then                         // Series2 \w肾
    if (X > 1000) and (2000 - X > 0) then           // X̒l 1000 2000@
      Series2.AddXY(2000 - X, Y1);                  // Otɒǉ
  X := X + 1;                                       // XCNg
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  Y1: double;
begin
  Timer1.Enabled := False;                          // Timer1 ~
  T := stopwatch1.Stop;                             // ^C}[ԑpXgbvEHb`~Ԏ擾
  stopwatch1.Start;                                 // ^C}[ԑpXgbvEHb`X^[g
  if X < 10 then Y1 := Random(100) / 3.3            // f[^[쐬
            else Y1 := Random(30) / 3.3 + 5;
  if X > 2000 then                                  // X2000zOtNA
    begin
      X := 0;
      Series1.Clear;
      Series2.Clear;
      Timer1.Enabled := True;                       // Timer1 X^[g
      exit;
    end;
  stopwatch2.Start;                                 // Oto͎ԑpXgbvEHb`X^[g
  Series1.AddXY(X, Y1);
  if Checkbox9.Checked then                         // Series2 \w肾
    if (X > 1000) and (2000 - X > 0) then           // X̒l 1000 2000@
      Series2.AddXY(2000 - X, Y1);                  // Otɒǉ
  X := X + 1;                                       // XCNg
  Timer1.Enabled := True;                           // Timer1 X^[g
end;

end.

