unit Main1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, Vcl.StdCtrls, Vcl.ExtCtrls, VCLTee.TeEngine, VCLTee.Series,
  VCLTee.TeeProcs, VCLTee.Chart, StopWatch, WPRCMMTimer, Mmsystem, MMTimer, Vcl.Buttons;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Button1: TButton;
    UpDown1: TUpDown;
    Chart1: TChart;
    Series1: TFastLineSeries;
    StopWatch1: TStopWatch;
    WPRCMMTimer1: TWPRCMMTimer;
    Button3: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    StopWatch2: TStopWatch;
    MMTimer1: TMMTimer;
    Button4: TButton;
    CheckBox1: TCheckBox;
    Timer2: TTimer;
    BitBtn1: TBitBtn;
    StopWatch3: TStopWatch;
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure WPRCMMTimer1Timer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button4Click(Sender: TObject);
    procedure MMTimer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Chart1AfterDraw(Sender: TObject);
  private
    { Private 錾 }
    procedure PrevScrool;       // XN[
    procedure ChartOut(DS: integer);
    procedure dataGet;
  public
    { Public 錾 }
    procedure WndProcd(var Msg:TMessage);             // TChart@sI^[h~
  end;

var
  Form1: TForm1;
  FWindowHandle:HWND;                       // WndProcd Handle

implementation

{$R *.dfm}

const
  MEMNO = 500;                                    // O[TCY
//  MEMNO = 15;
  GRFNO = 100;
//  GRFNO =  10;

var
  DataArray : array[0..MEMNO] of Double;          // O[
  MEMOCNT   : Integer;                            // [̈ʒu
  DATCONT   : Integer;                            // Otǉp[ʒu
  Gdat      : Double;                             // ̃TvOf[^[
  SCCount   : integer;                            // Abv_EpXN[\p
  LOOPEDF   : Boolean;                            // O[ǂtO
  SWatchT   : Extended;                           // XgbvEHb`̒l Otf[^[̏ݎ
  SWatchF   : Extended;                           // XgbvEHb`̒l ^C}[̈
  AfterCF   : Boolean;                            // Chart1AfterDrawg)tO

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  II : integer;
begin
  StopWatch3.Start;
  Series1.Clear;                                  // OtNA
  MEMOCNT := 0;                                   //
  UpDown1.Position := 0;
  SCCount := 0;                                   // Abv_EpVtgJE^[NA
  LOOPEDF := False;                               // O[tOZbg
  for II := 0 to MEMNO do                         // O[NA
    begin
      DataArray[II] := 0;
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);   // VXe^C}[̃X^[g
var
  Check,T : integer;
begin
  if WPRCMMTimer1.Enabled then exit;
  if MMTimer1.Enabled then exit;
  Val(Edit1.Text, T, Check);
  if Check <> 0 then exit;
  if T > 0 then Timer1.Interval := T;                           // ^C}[ԃZbg
  Form1.Canvas.TextOut(20,5,'Timer       ');
  Form1.Canvas.TextOut(20,35,'GraphDatain');
  Form1.Canvas.TextOut(20,65,'GraphOut   ');
  if Timer1.Enabled then begin                                  // Cl[u^C}[~
    Timer1.Enabled := False;
    Button3.Enabled := True;
    Button4.Enabled := True;
    Bitbtn1.Enabled := True;
    if Series1.Count >= GRFNO + 1 then UpDown1.Enabled := True; // Ot̉őɒBĂUpDown1{^\
    if LOOPEDF then UpDown1.Min := GRFNO - MEMNO                // [Ăꍇ̃VtgZbg
               else UpDown1.Min := GRFNO - MEMOCNT + 1;         // ĂȂꍇ̃VtgZbg
  end
  else begin
    UpDown1.Enabled := False;
    Button3.Enabled := False;
    Button4.Enabled := False;
    Bitbtn1.Enabled := False;
    Timer1.Enabled := True;
  end;
  Stopwatch2.Start;
end;

procedure TForm1.Button3Click(Sender: TObject);   // WPRCMMTimer
var
  Check,T : integer;
begin
  if Timer1.Enabled then exit;
  if MMTimer1.Enabled then exit;
  Val(Edit1.Text, T, Check);
  if Check <> 0 then exit;
  if T > 0 then WPRCMMTimer1.Interval := T;                           // ^C}[ԃZbg
  Form1.Canvas.TextOut(20,5,'WprcTimer   ');
  Form1.Canvas.TextOut(20,35,'GraphDatain');
  Form1.Canvas.TextOut(20,65,'GraphOut   ');
  if WPRCMMTimer1.Enabled then begin                            // Cl[u^C}[~
    Button1.Enabled := True;
    Button4.Enabled := True;
    Bitbtn1.Enabled := True;
    WPRCMMTimer1.Enabled := False;
    if Series1.Count >= GRFNO + 1 then UpDown1.Enabled := True; // Ot̉őɒBĂUpDown1{^\
    if LOOPEDF then UpDown1.Min := GRFNO - MEMNO                // [Ăꍇ̃VtgZbg
               else UpDown1.Min := GRFNO - MEMOCNT + 1;         // ĂȂꍇ̃VtgZbg
  end
  else begin
    WPRCMMTimer1.Enabled := True;
    UpDown1.Enabled := False;
    Button1.Enabled := False;
    Button4.Enabled := False;
    Bitbtn1.Enabled := False;
  end;
  Stopwatch2.Start;
end;

procedure TForm1.Button4Click(Sender: TObject);   // MMTimer
var
  Check,T : integer;
begin
  if Timer2.Enabled then exit;
  if Timer1.Enabled then exit;
  if WprcMMTimer1.Enabled then exit;
  Val(Edit1.Text, T, Check);
  if Check <> 0 then exit;
  if T > 0 then MMTimer1.Interval := T;                           // ^C}[ԃZbg
  Form1.Canvas.TextOut(20,5,'MMTimer     ');
  Form1.Canvas.TextOut(20,35,'GraphDatain');
  Form1.Canvas.TextOut(20,65,'GraphOut   ');
  if MMTimer1.Enabled then begin                                // Cl[u^C}[~
    Button1.Enabled := True;
    Button3.Enabled := True;
    Bitbtn1.Enabled := True;
    MMTimer1.Enabled := False;
    if Series1.Count >= GRFNO + 1 then UpDown1.Enabled := True; // Ot̉őɒBĂUpDown1{^\
    if LOOPEDF then UpDown1.Min := GRFNO - MEMNO                // [Ăꍇ̃VtgZbg
               else UpDown1.Min := GRFNO - MEMOCNT + 1;         // ĂȂꍇ̃VtgZbg
  end
  else begin
    UpDown1.Enabled := False;
    Button1.Enabled := False;
    Button3.Enabled := False;
    Bitbtn1.Enabled := False;
    Timer2.Enabled := True;                                     // MMTimerX^[gp^C}[Jn ^C}[̒l
//    MMtimer1.Enabled := True;
  end;                                                          // ^C}[ŒxȂ Button Diseble \XVȂ
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  timeendPeriod(1);                         // ^C}[x
  DeallocateHWnd(FWindowHandle);            // WndProcd Handle ̔j
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FWindowHandle := AllocateHWnd(WndProcd);  // WndProcd Handle  
  Top := (Screen.Height - Height) div 3;
  Left := (Screen.Width - Width) div 2;
  Chart1.LeftAxis.Automatic := False;
  Chart1.BottomAxis.Automatic := False;
  Chart1.LeftAxis.Maximum := 10;
  Chart1.LeftAxis.Minimum := 0;
  Chart1.BottomAxis.Maximum := GRFNO;
  Chart1.BottomAxis.Minimum := 0;
  UpDown1.Min := GRFNO - MEMNO;
  UpDown1.Max := 0;
  Timer1.Enabled := False;
  Timer1.Interval := 31;
  Timer2.Enabled := False;
  Timer2.Interval := 62;
  WPRCMMTimer1.Enabled := False;
  WPRCMMTimer1.Interval := 31;
  MMTimer1.Enabled := False;
  MMTimer1.Interval := 31;
  Edit1.Text := '31';
  timeBeginPeriod(1);                       // ^C}[̐xݒ
end;

procedure TForm1.WndProcd(var Msg:TMessage);        // TChart@sI^[h~
begin
  with Msg do
    case Msg of
      WM_USER:
        try
          Form1.Canvas.TextOut(20,20,FloatTostrF(SWatchF,FFFixed,7,4) + '           ');   // ^C}[ԕ\
          ChartOut(WPARAM);                                               // Ot
        except
          Application.HandleException(Self);
        end;
      else
        Result := DefWindowProc(FWindowHandle,Msg,WParam,LParam);             // WM_USER@ȊȌ
    end;
end;

procedure TForm1.MMTimer1Timer(Sender: TObject);
begin
  SWatchF := Stopwatch2.Stop;                                                 // ^C}[ԑ
  Stopwatch2.Start;                                                           // ^C}[ԊJn
  dataGet;                                                                    // f[^[쐬
  if CheckBox1.Checked then                                                   // send  post ؑւ悤
      SendMessage(FWindowHandle, WM_USER, MEMOCNT, 0)                         // send\bZ[WM
    else
      PostMessage(FWindowHandle, WM_USER, MEMOCNT, 0);                        // Post\bZ[WM
end;

procedure TForm1.dataGet;           // \pf[^[쐬
begin                               // {͑f[^[ʐMɂ擾邪A킪̂ŉɍ쐬
  if MEMOCNT > MEMNO then begin     // [v[Ă烋[vJE^[[ɖ߂
    LOOPEDF := True;
    MEMOCNT := 0;
  end;
  Gdat := Random * 8 + 1;           // 
  DataArray[MEMOCNT] := Gdat;       // [v[ɃZbg
  inc(MEMOCNT);                     // [vJE^[CNg
end;

procedure TForm1.Chart1AfterDraw(Sender: TObject);
begin
  if AfterCF then Canvas.TextOut(20,80,FloatTostrF(StopWatch3.Stop,FFfixed,7,4) + '           ');   // ̏o
end;

procedure TForm1.ChartOut(DS: integer);                 //f[^[Ot
var
  II : integer;
begin
  StopWatch1.Start;                                     // Otݎԑ
  StopWatch3.Start;
  AfterCF := True;                                      // Chart1AfterDrawg)tO
  if Series1.Count <= GRFNO then begin                  // OtMAXɒBĂȂ
      Series1.AddXY(Series1.Count,DataArray[DS - 1]);   // Ō̔zf[^[
    end
    else                                                // OtMAXzĂ
    begin
     for II := 0 to GRFNO do begin                      //  0@ GRFNO 
      DATCONT := MEMOCNT - GRFNO - 1 + II;              // z̈ʒǔvZ
      if DATCONT < 0 then                               // [ȉ
        DATCONT := MEMNO + DATCONT + 1;                 // 擪̈ʒuČvZ
      Series1.YValue[II] := DataArray[DATCONT];         // zf[^[珑
     end;
    end;
  SWatchT := StopWatch1.Stop;                           // ݎԑ
  Canvas.TextOut(20,50,FloatTostrF(SWatchT,FFfixed,7,4) + '           ');   // ̏o
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  dataGet;                                              // \pf[^[쐬
  ChartOut(MEMOCNT);                                    // Oto
  SWatchF := StopWatch2.Stop;                           // ^C}[ԑ
  Canvas.TextOut(20,20,FloatTostrF(SWatchF,FFFixed,7,4) + '           ');  // ^C}[ԕ\
  StopWatch2.Start;                                     // ^C}[ԑJn
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
  Timer2.Enabled := False;                              // gDiseble
  MMTimer1.Enabled := True;                             // MMtimer X^[g
  Stopwatch2.Start;                                     // XgbvEHb`X^[g
end;

procedure TForm1.PrevScrool;                            // OtXN[
var
  II : integer;
begin
  if Series1.Count <= GRFNO then exit;                  // Ot MAXɒBĂȂI
  StopWatch3.Start;
  for II := 0 to GRFNO do begin                         //  0  MAX@ zf[^[oOtɏ
    DATCONT := MEMOCNT - GRFNO + II - 1 + SCCount;      // zʒuvZ
    if DATCONT < 0 then                                 // zʒuvZ0ȉɂȂ
      DATCONT := MEMNO + DATCONT + 1;                   // 擪̈ʒuɍČvZ
    Series1.YValue[II] := DataArray[DATCONT];           // Otɏ
  end;
end;

{ ̗ @ł̓XN[x̂ŁA^ʂ̕@قǂ }
procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);  // Abv_EJE^[NbN
begin
  if Button = btnext then                               // փXN[
    begin
      inc(SCCount);
      PrevScrool;
    end;
  if Button = btprev then                               // EփXN[
    begin
      dec(SCCount);
      PrevScrool;
    end;
end;

procedure TForm1.WPRCMMTimer1Timer(Sender: TObject);
begin
  dataGet;                                              // f[^[̎擾
  ChartOut(MEMOCNT);                                    // Ot
  Canvas.TextOut(20,20,FloatTostrF(Stopwatch2.Stop,FFFixed,7,4) + '           ');   // ^C}[ԕ\
  Stopwatch2.Start;                                     // ^C}[ԑJn
end;

end.
